/**
 * Copyright (c) 2010-2018, Zoltan Ujhelyi, Istvan Rath, Daniel Varro, IncQuery Labs Ltd.
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-v20.html.
 *  * 
 * SPDX-License-Identifier: EPL-2.0
 */
package org.eclipse.viatra.query.patternlanguage.emf.vql.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.viatra.query.patternlanguage.emf.vql.CallableRelation;
import org.eclipse.viatra.query.patternlanguage.emf.vql.ClassType;
import org.eclipse.viatra.query.patternlanguage.emf.vql.ClosureType;
import org.eclipse.viatra.query.patternlanguage.emf.vql.PathExpressionConstraint;
import org.eclipse.viatra.query.patternlanguage.emf.vql.PatternLanguagePackage;
import org.eclipse.viatra.query.patternlanguage.emf.vql.ReferenceType;
import org.eclipse.viatra.query.patternlanguage.emf.vql.ValueReference;
import org.eclipse.viatra.query.patternlanguage.emf.vql.VariableReference;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Path Expression Constraint</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.viatra.query.patternlanguage.emf.vql.impl.PathExpressionConstraintImpl#getTransitive <em>Transitive</em>}</li>
 *   <li>{@link org.eclipse.viatra.query.patternlanguage.emf.vql.impl.PathExpressionConstraintImpl#getEdgeTypes <em>Edge Types</em>}</li>
 *   <li>{@link org.eclipse.viatra.query.patternlanguage.emf.vql.impl.PathExpressionConstraintImpl#getSourceType <em>Source Type</em>}</li>
 *   <li>{@link org.eclipse.viatra.query.patternlanguage.emf.vql.impl.PathExpressionConstraintImpl#getSrc <em>Src</em>}</li>
 *   <li>{@link org.eclipse.viatra.query.patternlanguage.emf.vql.impl.PathExpressionConstraintImpl#getDst <em>Dst</em>}</li>
 * </ul>
 *
 * @generated
 */
public class PathExpressionConstraintImpl extends ConstraintImpl implements PathExpressionConstraint
{
	/**
	 * The default value of the '{@link #getTransitive() <em>Transitive</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTransitive()
	 * @generated
	 * @ordered
	 */
	protected static final ClosureType TRANSITIVE_EDEFAULT = ClosureType.ORIGINAL;

	/**
	 * The cached value of the '{@link #getTransitive() <em>Transitive</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTransitive()
	 * @generated
	 * @ordered
	 */
	protected ClosureType transitive = TRANSITIVE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getEdgeTypes() <em>Edge Types</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEdgeTypes()
	 * @generated
	 * @ordered
	 */
	protected EList<ReferenceType> edgeTypes;

	/**
	 * The cached value of the '{@link #getSourceType() <em>Source Type</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSourceType()
	 * @generated
	 * @ordered
	 */
	protected ClassType sourceType;

	/**
	 * The cached value of the '{@link #getSrc() <em>Src</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSrc()
	 * @generated
	 * @ordered
	 */
	protected VariableReference src;

	/**
	 * The cached value of the '{@link #getDst() <em>Dst</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDst()
	 * @generated
	 * @ordered
	 */
	protected ValueReference dst;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PathExpressionConstraintImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass()
	{
		return PatternLanguagePackage.Literals.PATH_EXPRESSION_CONSTRAINT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ClosureType getTransitive()
	{
		return transitive;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTransitive(ClosureType newTransitive)
	{
		ClosureType oldTransitive = transitive;
		transitive = newTransitive == null ? TRANSITIVE_EDEFAULT : newTransitive;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__TRANSITIVE, oldTransitive, transitive));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ReferenceType> getEdgeTypes()
	{
		if (edgeTypes == null)
		{
			edgeTypes = new EObjectContainmentEList<ReferenceType>(ReferenceType.class, this, PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__EDGE_TYPES);
		}
		return edgeTypes;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ClassType getSourceType()
	{
		return sourceType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSourceType(ClassType newSourceType, NotificationChain msgs)
	{
		ClassType oldSourceType = sourceType;
		sourceType = newSourceType;
		if (eNotificationRequired())
		{
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__SOURCE_TYPE, oldSourceType, newSourceType);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSourceType(ClassType newSourceType)
	{
		if (newSourceType != sourceType)
		{
			NotificationChain msgs = null;
			if (sourceType != null)
				msgs = ((InternalEObject)sourceType).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__SOURCE_TYPE, null, msgs);
			if (newSourceType != null)
				msgs = ((InternalEObject)newSourceType).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__SOURCE_TYPE, null, msgs);
			msgs = basicSetSourceType(newSourceType, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__SOURCE_TYPE, newSourceType, newSourceType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VariableReference getSrc()
	{
		return src;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSrc(VariableReference newSrc, NotificationChain msgs)
	{
		VariableReference oldSrc = src;
		src = newSrc;
		if (eNotificationRequired())
		{
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__SRC, oldSrc, newSrc);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSrc(VariableReference newSrc)
	{
		if (newSrc != src)
		{
			NotificationChain msgs = null;
			if (src != null)
				msgs = ((InternalEObject)src).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__SRC, null, msgs);
			if (newSrc != null)
				msgs = ((InternalEObject)newSrc).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__SRC, null, msgs);
			msgs = basicSetSrc(newSrc, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__SRC, newSrc, newSrc));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ValueReference getDst()
	{
		return dst;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDst(ValueReference newDst, NotificationChain msgs)
	{
		ValueReference oldDst = dst;
		dst = newDst;
		if (eNotificationRequired())
		{
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__DST, oldDst, newDst);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDst(ValueReference newDst)
	{
		if (newDst != dst)
		{
			NotificationChain msgs = null;
			if (dst != null)
				msgs = ((InternalEObject)dst).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__DST, null, msgs);
			if (newDst != null)
				msgs = ((InternalEObject)newDst).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__DST, null, msgs);
			msgs = basicSetDst(newDst, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__DST, newDst, newDst));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString()
	{
		return org.eclipse.viatra.query.patternlanguage.emf.util.ASTStringProvider.INSTANCE.doSwitch(this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
	{
		switch (featureID)
		{
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__EDGE_TYPES:
				return ((InternalEList<?>)getEdgeTypes()).basicRemove(otherEnd, msgs);
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__SOURCE_TYPE:
				return basicSetSourceType(null, msgs);
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__SRC:
				return basicSetSrc(null, msgs);
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__DST:
				return basicSetDst(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType)
	{
		switch (featureID)
		{
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__TRANSITIVE:
				return getTransitive();
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__EDGE_TYPES:
				return getEdgeTypes();
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__SOURCE_TYPE:
				return getSourceType();
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__SRC:
				return getSrc();
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__DST:
				return getDst();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue)
	{
		switch (featureID)
		{
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__TRANSITIVE:
				setTransitive((ClosureType)newValue);
				return;
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__EDGE_TYPES:
				getEdgeTypes().clear();
				getEdgeTypes().addAll((Collection<? extends ReferenceType>)newValue);
				return;
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__SOURCE_TYPE:
				setSourceType((ClassType)newValue);
				return;
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__SRC:
				setSrc((VariableReference)newValue);
				return;
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__DST:
				setDst((ValueReference)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID)
	{
		switch (featureID)
		{
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__TRANSITIVE:
				setTransitive(TRANSITIVE_EDEFAULT);
				return;
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__EDGE_TYPES:
				getEdgeTypes().clear();
				return;
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__SOURCE_TYPE:
				setSourceType((ClassType)null);
				return;
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__SRC:
				setSrc((VariableReference)null);
				return;
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__DST:
				setDst((ValueReference)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID)
	{
		switch (featureID)
		{
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__TRANSITIVE:
				return transitive != TRANSITIVE_EDEFAULT;
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__EDGE_TYPES:
				return edgeTypes != null && !edgeTypes.isEmpty();
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__SOURCE_TYPE:
				return sourceType != null;
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__SRC:
				return src != null;
			case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__DST:
				return dst != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
	{
		if (baseClass == CallableRelation.class)
		{
			switch (derivedFeatureID)
			{
				case PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__TRANSITIVE: return PatternLanguagePackage.CALLABLE_RELATION__TRANSITIVE;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
	{
		if (baseClass == CallableRelation.class)
		{
			switch (baseFeatureID)
			{
				case PatternLanguagePackage.CALLABLE_RELATION__TRANSITIVE: return PatternLanguagePackage.PATH_EXPRESSION_CONSTRAINT__TRANSITIVE;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

} //PathExpressionConstraintImpl
